# 变更日志

## v1.20.4 (2017.12.5)

* 特性 : 一周会议添加气科院访问路径
* fix(setting): 商务合作不展示具体人员
* 特性 (setting): 商务合作中添加气科院

## (2017.7.5)

* 特性：添加启动页可配置特性
* 特性：添加关于我们可配置 （bad: 二者使用在 default 配置中有效）

## v1.20.3 (2017.6.5)

* 特性：信息发布列表页的缓存功能（第一页）

## v1.20.2 (2017.5.23)

* fix(vpn): 无法获取 vpn 状态时，app 所有的 http 请求均会阻塞。处理方法：添加获
  取 vpn 状态超时，超过 5 秒（ios ）或者 10 秒（android ），则认为 vpn 登录成功
  。

## v1.20.1 (2017.5.23)

* 特性：在 app 初始化时，更新 app 的配置。

## v1.20.0 (2017.5.16)

* 优化： 在 post 请求中添加 recordId 和 flowType 字段，便于记录访问的模块

## v1.19.4

* feature( 定制 )：国家局按钮样式定制更改
* fix(nxjQj): 起草的年休假请假可以不可以直接发送出去的 bug。

## v1.18.0

* fix: 在 Android 上预览文件名后缀是大写的文件时出错。
* fix(upgrade): 点击安装提示界面的确定按钮，在 ios 中没有反应。
* feat(moduleConfig): 模块的可配置性功能。

## v1.17.0 (2017.1.4)

* 添加：试用版公文查询功能禁用
* 添加：试用版流程性操作按钮禁用。
* 优化：默认情况下 config.js 的获取到的是默认配置。
* 优化：去掉自己可以给自己绑定的功能。
* 特性：支持为不同的设备平台和版本设置不同的配置 (config.json)。

### 为不同设备平台设置不同的配置

可以为不同的设备平台设置不同的配置，这些平台包括 Android 和 iOS。这里说的配置是
指项目中的`config.json`文件配置。

例如：

```json
[
  {
    "id": "gjjoa",
    "title": "国家局(vpn)",
    "platformCategory": "gjjoa",
    "appId": "gjjoa",
    "appName": "gjjoa",
    "server": "http://10.20.67.197",
    "socketServer": "ws://10.20.67.197:8887",
    "vpnServer": "https://vpn.cma.gov.cn:443"
  },
  {
    "id": "gjjoa-ios8",
    "platform": "ios8",
    "platformCategory": "gjjoa",
    "title": "国家局",
    "appId": "gjjoa",
    "appName": "gjjoa",
    "server": "http://112.126.73.50:81"
  }
]
```

其中重要的配置属性是：

* `platformCategory`: 表示此项配置将会加入到 “ 为不同平台设置不同配置 ” 的计算中
  ，所有`platformCategory`属性相同的配置项目组成一个组，最终通过计算，只会选择出
  一个。
* `platform`：表示此项配置是为什么平台定制的配置。

从一组配置项中选择出平台特定的配置项的规则：

* 这组配置项中有完全匹配`platform`的，则直接应用此项配置；
* 否则选择默认配置项（即`platform`未指定的配置项）。

## v1.15.3 (2016.12.9)

* feature( 定制 )：实现 “ 是否需要密码登录 ” 的可定制化需求
* feature( 定制 )：给湖南配置上不需要密码登录。
* improve(info): 通过配置按省份显示信息发布。

## v1.15.0 (2016.11.24)

* improve(linker): 联系人页面中显示该部门下的职务。
* improve(afix): 当附件列表获取失败时，添加重新获取按钮。
* fix(info): 信息发布的详情页获取时，更改附件的获取方式。

## v1.14.12 (2016.11.18)

* feature(notion): 签字时，意见可以为空，必须打开意见保存后才能发送。

由于撤办造成的通知中的垃圾数据

```sql
update flow_workflowinfo f set f.signtag = '8' where f.signtag = '0';
update flow_workflowinfo f set f.signtag = '0' where f.signtag = '8';
```

## v1.14.10 (2016.11.14)

* fix(upgrade): 点击安装提示界面的确定按钮，在 ios 中没有反应。
* fix: 在 Android 6.0- 无法启动 app。

## v1.14.9 (2016.11.10)

* 重构：去掉多余的`waitLoginVpn()`方法。

## v1.14.7 (2016.11.8)

* fix(AppConfig): 修复因`ApplicationConfig#getKeyValueUntilNoEmpty(key,
  callback)`方法缺少对`callback`的空判断而导致 app 无法使用的 bug。
* feature: 华为手机权限设置提醒。

## v1.14.6 (2016.11.7)

* feature: 支持等待 VPN 连接成功后，再发送 ajax 请求。

## v1.14.5 (2016.11.3)

* feature: 支持 Android app 自动下载 app 安装包并弹出安装界面。

## v1.14.4 (2016.11.2)

* fix: 在 VPN 环境中，刚刚打开 app 时，可能会 CA 登录失败。

## v1.14.3 (2016.11.1)

* fix: 在 VPN 环境中，无法注册设备 id 与离线消息通道 id 的关联关系。
* fix: 在 app 没有登录任何用户之前，无法注册设备 id 与离线消息通道 id 的关联关系
  。
* fix: 发文发电中的内容没有首行缩进样式。

## v1.14.2 (2016.11.1)

* typo: 发文发电中的 “ 承办处室 ” 改成 “ 承办单位 ”。
* typo: 授权提示中，不恰当的提示语。

## v1.14.0 (2016.10.27)

* feature(offline): 新增离线推送功能：Android 收到待办事项统计条数通知，iOS 收到
  具体待办事项通知。
* feature(core): 支持一人多岗的切换。
* fix(mail): 打开 CMA 邮箱、公共邮箱没有等待和错误提示。
* fix(login): app 自动登录时，无限登录。
* improve(setting): 设置 -> 省份选择，改成切换服务器。
* fix: iOS app ：无法读取 CA 证书。
* fix: 修复深信服 VPN 连接不稳定的 bug。
* fix: 部门人员树，点不中，导致无法打开部门人员树。
* fix: 人员部门树导航有问题。
* improve （ toberead）: 待阅中的转发按钮添加配置。

## v1.13.2 (2016.10.17)

* fix(mail): 打开不了 cma 邮箱的附件。
* fix( 公文 )：word 红头转 pdf 后，字体还不对，是否确认安装方正小标宋简体。
* improve( 邮箱 ):CMA 邮箱的地址换成域名形式的。
* improve(toberead): 待阅的已阅列表有性能问题，打开时会页面卡死。
* fix(linker): 通讯录中的人员列表和待阅事宜中 “ 转发 ” 功能弹出的人员选择列表有
  差别，通讯录都正常，但人员选择列表的排序和部门选择处都有 .
* fix(toberead): 待阅 - 转发中的部门人员树打开层进的单位时，上面导航不对。
* improve(vpn): 验证 afnetworking 升级与 VPN 通道是否可以兼容。
* improve(android): Android 中的 vpn 连接设置支持 https 连接不写默认端口号 443。
* improve(android): 第一次安装的 app，有自动更新时，没有下载增量更新包，而是下载
  整个更新包。
* fix(android): Android 自动更新会出现无限循环的现象。
* fix(android): Android 自动更新会出现无限循环的现象。
* fix(android): Android app ： backbutton 方式退出 app 后再打开 app，会出现白屏
  现象。
* fix(android): Android app: 在华为 P9 Plus（Android 6.0 ）中，无法使用新版本的
  VPN SDK。
* fix(android): 解决退出 Android app 后，再次打开 app，VPN 无法连接的问题。
* fix(android): 华为 P9 手机上无法导入 VPN 证书
* fix(android): APP 证书登录失败。
* fix(android): Android app: 无法导入 CA 证书
* fix(android): Android VPN 在多次打开时，有 40% 的几率不会连接上 VPN。
* fix(android): Android ： VPN 导入时输入密码的界面有双 title。
* fix(ios): iOS10 不兼容。
* fix(ios): 使用 VPN 通道时，app 打开时没有版本更新提醒。
* improve(ios): 修正 Content Security Policy 的配置，解决 iOS app 白屏 bug。

## v1.13.0

* fix(linker): 在 Android5.1+ 以上手机不能将联系人添加到通讯录。
* fix(linker): 删除不了用户图像。
* improve(dbsy): 待办事宜的待办列表中，没有发送人，则不显示 “ 发送人 ” 选项。
* improve(mail): 邮件页面显示不同的 title，并显示正确的返回按钮标题。
* fix(upgrade): 有更新需要安装 app 时，同时打开了多个确认框，导致无法取消。

* improve(info): 发文发电列表页中的单位显示司级单位
* improve(info): 详情页首行空的不是中文字符的改为中文字符。
* 设置中，添加【内部分发】按钮的流程确认框。
* 联系人 - 详情页中，删除按钮太扎眼，已优化。
* 联系人 - 所有联系人中，进入某一部门时，最开始的人被隐藏，应该展示最上面个的人
  。
* 有些 iOS 版本中（如 iOS8 中），公文的已办理列表页的搜索功能中的搜索条件是换行
  显示的，应该不换行。

## v1.12.3 2016.09.08

* 修复 bug：获取 admin 的用户信息和图片会导致页面卡死。

## v1.12.2

* feat(device): 支持一个设备同时绑定多个人。
* feat(device): 设备列表显示审批中和审批未通过的设备。
